@echo off
echo **************************************
echo *Welcome to the Firefox Browser Live-demo CD!*
echo **************************************
echo.
rem Default values
SET FirefoxStartDir=%~dp0
SET FirefoxTempDir=
SET JUMP_BACK_TO=

rem Evaluate Passed Parameters
IF /i "%~1"=="/?" goto HOW_TO_USE
IF /i "%~1"=="-?" goto HOW_TO_USE
IF /i "%~1"=="-h" goto HOW_TO_USE
IF /i "%~1"=="--h" goto HOW_TO_USE
IF NOT "%~1"=="" goto WITH_PARAM
IF "%~1"=="" goto TEMP

rem Parameter passed in
:WITH_PARAM
SET FirefoxTempDir=%~1
SET JUMP_BACK_TO=TEMP
goto PREPARE_PATH

rem Determine Temp Directory (Check TEMP variable)
:TEMP
IF "%TEMP%"=="" (
   goto TMP
)
SET FirefoxTempDir=%TEMP%
SET JUMP_BACK_TO=TMP
goto PREPARE_PATH

rem Determine Temp Directory (Check TMP Variable)
:TMP
IF "%TMP%"=="" (
   goto LW_D
)
SET FirefoxTempDir=%TMP%
SET JUMP_BACK_TO=LW_D
goto PREPARE_PATH

rem Try D: drive for temp...
:LW_D
SET FirefoxTempDir=D:\
SET JUMP_BACK_TO=LW_C
goto PREPARE_PATH

rem Try C: drive for temp...
:LW_C
SET FirefoxTempDir=C:\
SET JUMP_BACK_TO=NO_VALID_PATH_FOUND
goto PREPARE_PATH

:NO_VALID_PATH_FOUND
echo ERROR: No valid temporary path was found.
exit /b

:COPY_NOW
echo Copying Firefox to a temporary local directory...
echo       SOURCE: %FirefoxStartDir% 
echo  DESTINATION: %FirefoxTempDir%
echo.
xcopy %FirefoxStartDir%* %FirefoxTempDir% /E /Q >nul 2>nul
if errorlevel 1 (
   echo ERROR: Unable to copy Firefox to temp directory.  Aborting.
   pause
   goto CLEANUP
)
echo Starting Firefox...
pushd %FirefoxTempDir%
PortableFirefox.exe file:///%FirefoxStartDir%/profile/demo/index.html
popd
if errorlevel 1 (
   pause
)
echo Closing Firefox...
rem Pause for 5 seconds to ensure Firefox is fully closed
PING 1.1.1.1 -n 1 -w 5000 >NUL

:CLEANUP
echo Cleaning up temporary files...
if errorlevel 0 (
   pause
)

rmdir /S /Q %FirefoxTempDir%
if errorlevel 1 (
   pause
)
exit /b

:HOW_TO_USE
echo "PortableFirefoxLive /?"
echo      Display this help information
echo "PortableFirefoxLive"
echo      Starts Firefox in one of the following locations:
echo      TEMP, TMP, D:\ und C:\
echo "PortableFirefoxLive <driver letter and path>"
echo      Starts Firefox in the indicated path.  On failure, tries above.
pause
exit /b

:PREPARE_PATH
IF NOT EXIST %FirefoxTempDir% (
   echo %FirefoxTempDir% not found
   SET FirefoxTempDir=
   goto %JUMP_BACK_TO%
)

:AGAIN
IF "%FirefoxTempDir:~-1%"=="\" SET FirefoxTempDir=%FirefoxTempDir:~0,-1%
IF "%FirefoxTempDir:~-1%"=="\" goto AGAIN
SET FirefoxTempDir=%FirefoxTempDir%\FirefoxTempDir\
md %FirefoxTempDir% 2>nul
if errorlevel 1 (
   echo ERROR: No write access to %FirefoxTempDir% - Aborting
   SET FirefoxTempDir=
   goto %JUMP_BACK_TO%
)
goto COPY_NOW

rem +++ Adapted From: OPERA FROM USB-STICK - WWW.TORSTEN-KEIL.NET +++
rem +++ LAST LINE OF SCRIPT +++